package eu.jonahbauer.raytracing.render;

import org.jetbrains.annotations.NotNull;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;

public final class ImageIO {
    private ImageIO() {
        throw new UnsupportedOperationException();
    }

    public static void write(@NotNull Image image, @NotNull Path path) throws IOException {
        try (var out = Files.newBufferedWriter(path)) {
            out.write("P3\n");
            out.write(String.valueOf(image.width()));
            out.write(" ");
            out.write(String.valueOf(image.height()));
            out.write("\n255\n");

            var it = image.pixels().iterator();
            while (it.hasNext()) {
                var color = it.next();
                out.write(String.valueOf(color.red()));
                out.write(" ");
                out.write(String.valueOf(color.green()));
                out.write(" ");
                out.write(String.valueOf(color.blue()));
                out.write("\n");
            }
        }
    }
}
